void cd_misc();

uint8 cdrom_read_reg0();
uint8 cdrom_read_reg1();
uint8 cdrom_read_reg2();
uint8 cdrom_read_reg3();
void cdrom_write_reg0(uint8 c);
void cdrom_write_reg1(uint8 c);
void cdrom_write_reg2(uint8 c);
void cdrom_write_reg3(uint8 c);

void cd_reset();
void cddma();

int cd_init();
void cd_close();
void cd_getTD(int nr,char *result);
void cd_getTN(char *result);
void cd_play(char *param);
void cd_stop();
void cd_setvol();
void cd_read(char *param);
void cd_setmode(char mode);
void cd_boot();

#define CdlSync		0x00
#define CdlNop		0x01
#define CdlSetloc	0x02
#define CdlPlay		0x03
#define CdlForward	0x04
#define CdlBackward	0x05
#define CdlReadN	0x06
#define CdlStandby	0x07
#define CdlStop		0x08
#define CdlPause	0x09
#define CdlInit		0x0a
#define CdlMute		0x0b
#define CdlDemute	0x0c
#define CdlSetfilter	0x0d
#define CdlSetmode	0x0e
#define CdlGetparam	0x0f
#define CdlGetlocL	0x10
#define CdlGetlocP	0x11
#define CdlGetTN	0x13
#define CdlGetTD	0x14
#define CdlSeekL	0x15
#define CdlSeekP	0x16
#define CdlTest		0x19
#define CdlID		0x1a
#define CdlReadS	0x1b
#define CdlReset	0x1c
#define CdlReadTOC	0x1e

unsigned char cdResultReady;
unsigned char cdResultP;
unsigned char cdResult[8];
unsigned char cdStat;
unsigned char cdParam[8];
unsigned char cdCtl;
unsigned char cdParamP;
unsigned char cdResultC;
unsigned char cdResultTN[6];
unsigned char cdResultTD[4];
unsigned char cdSetSector[4];
int cdTrack;
int cdPlay;
uint8 cdIoStatus;
int cdMode;
int cdReaded;
int cdReset;
int cdV;
int cdRErr;
int cdIrqNextTime;
int vsyncCount;
int ReadRetry;
uint16 cd_mvolL;
uint16 cd_mvolR;

#define BUFFER_SIZE	64*4
#define DATA_SIZE	2340
uint8 cd_buffer[DATA_SIZE * BUFFER_SIZE];
int lastread;