typedef uint64  ptsize;
typedef uint32  opsize;

typedef struct {
	uint32	gpr[32];
#define		kcp0	128
	uint32	cp0[32];
#define		kgte1	256
	uint32	gte1[32];
#define		kgte2	384
	uint32	gte2[32];
#define		klo		512
	uint32	LO;
#define		khi		516
	uint32	HI;
#define		ktw		520
	uint32	pc0;
#define		knstp	524
	uint32	nstp;

#define		kmptr	528
	ptsize	mptr;
#define		khwr	536
	ptsize	hwr;
#define		kstack  544  
	ptsize	stack;
#define		kflow	552
	ptsize	flow;
#define		kpad	560
	ptsize	pad;
#define		kyon	568
	uint64	yon;	/*Contains the booleanity of branches 1=jump 0=no way*/
#define		kdiv	576
	uint64	div;
#define		khre    584
	uint64	hre;
#define		ktest   592
	uint64	test;
#define		kr15    600
	uint64	r15;
#define		kwrl    608
	ptsize	wrl;
#define		krm8u   616
	ptsize	rm8u;
#define		krm8s   624
	ptsize	rm8s;
#define		krm16u  632
	ptsize	rm16u;
#define		krm16s  640
	ptsize	rm16s;
#define		krm32   648
	ptsize	rm32;
#define		kwm8    656
	ptsize	wm8;
#define		kwm16   664
	ptsize	wm16;
#define		kwm32   672
	ptsize	wm32;
#define		kgtop   680
	ptsize	gtop;
#define		kpbuf	688
	uint32	pbuf;
#define		kadre	692
	uint32	adre;
#define		kaxp	696
	uint64	axpregs;
#define		kcaca	704
	uint64	caca;
#define		krc		712
	uint64	rc;
} context;

