#define RC 8 /*Context register*/
#define RN 6 /*Number of instructions register*/

#define SAVE_AXP_REGS			header[p++]=axp_stq(26,RC,kflow);\
								header[p++]=axp_stq(15,RC,kr15);\
								header[p++]=axp_ldq(7,RC,kcaca);

#define RESTORE_AXP_REGS		alphaptr[n++]=axp_ldq(26,RC,kflow);\
								alphaptr[n++]=axp_ldq(15,RC,kr15);\
								alphaptr[n++]=axp_stq(7,RC,kcaca);

#define BACK_TO_HANDLE_FLOW		m=push_mips(alphaptr+n);n+=m;\
								RESTORE_AXP_REGS\
								alphaptr[n++]=axp_ret(31,26);

#define LOAD_REG(r,m)	if (r%2)	alphaptr[n++]=axp_srl_i(15+r/2,32,m);\
						else		alphaptr[n++]=axp_zap_i(15+r/2,0xf0,m);

#define SAVE_REG(r,m)	if (r!=0) {\
							if (r%2) {\
								alphaptr[n++]=axp_zap_i(15+r/2,0xf0,15+r/2);\
								alphaptr[n++]=axp_sll_i(m,32,m);\
							} else {\
								alphaptr[n++]=axp_zap_i(15+r/2,0x0f,15+r/2);\
								alphaptr[n++]=axp_zap_i(m,0xf0,m);\
							}\
							alphaptr[n++]=axp_bis(15+r/2,m,15+r/2);\
						}
/*
#define LOAD_REG(r,m)	alphaptr[n++]=axp_ldl(m,RC,4*r);\
						alphaptr[n++]=axp_zap_i(m,0xf0,m);
#define SAVE_REG(r,m)   alphaptr[n++]=axp_stl(m,RC,4*r);
*/
#define START_CC		alphaptr[n++]=axp_rpcc(5);
#define STOP_CC			alphaptr[n++]=axp_rpcc(4);\
						alphaptr[n++]=axp_subl(4,5,5);\
						alphaptr[n++]=axp_addl(5,7,7);

int load_adress(uint32 *dest,unsigned long am,int unsigned reg);

void static inline load_imm(uint16 shim,int unsigned m) {
char unsigned i1,i2;
i1=shim &0xff;
i2=(shim>>8)&0xff;
alphaptr[n++]=axp_bis_i(31,i2,m);
alphaptr[n++]=axp_sll_i(m,8,m);
alphaptr[n++]=axp_bis_i(m,i1,m);
}

void static inline load_imm32(uint32 shim,int unsigned m) {
char unsigned i1,i2,i3,i4;
i1=shim &0xff;
i2=(shim>>8)&0xff;
i3=(shim>>16)&0xff;
i4=(shim>>24)&0xff;
alphaptr[n++]=axp_bis_i(31,i4,m);
alphaptr[n++]=axp_sll_i(m,8,m);
alphaptr[n++]=axp_bis_i(m,i3,m);
alphaptr[n++]=axp_sll_i(m,8,m);
alphaptr[n++]=axp_bis_i(m,i2,m);
alphaptr[n++]=axp_sll_i(m,8,m);
alphaptr[n++]=axp_bis_i(m,i1,m);
}
