void DYN_XX();

void DYN_GTE();

void DYN_LUI();

void DYN_ORI();
void DYN_ANDI();
void DYN_XORI();
void DYN_OR();
void DYN_AND();
void DYN_XOR();
void DYN_NOR();

void DYN_NOP();

void DYN_SUB();
void DYN_SUBU();
void DYN_ADD();
void DYN_ADDU();
void DYN_ADDI();
void DYN_ADDIU();

void DYN_SLL();
void DYN_SRL();
void DYN_SRA();

void DYN_SLLV();
void DYN_SRLV();
void DYN_SRAV();

void DYN_SB();
void DYN_SH();
void DYN_SW();

void DYN_SLT();
void DYN_SLTU();
void DYN_SLTI();
void DYN_SLTIU();

void DYN_LW();
void DYN_LB();
void DYN_LH();
void DYN_LBU();
void DYN_LHU();

void DYN_BNE();
void DYN_BEQ();
void DYN_BLEZ();
void DYN_BGTZ();
void DYN_BLTZ();
void DYN_BGEZ();
void DYN_BGEZAL();
void DYN_BLTZAL();


void DYN_J();
void DYN_JAL();
void DYN_JR();
void DYN_JALR();

void DYN_MFLO();
void DYN_MTLO();
void DYN_MFHI();
void DYN_MTHI();
void DYN_DIV();
void DYN_DIVU();
void DYN_MUL();
void DYN_MULU();

void DYN_C0_MFC();
void DYN_C0_MTC();
void DYN_C0_RFE();

void DYN_BREAK();
void DYN_SYSC();

void DYN_LWL();
void DYN_LWR();
void DYN_SWL();
void DYN_SWR();

void DYN_SWC2();
void DYN_LWC2();

void (*dyn_special[64])(void)={	DYN_SLL,DYN_XX,DYN_SRL,DYN_SRA,DYN_SLLV,DYN_XX,DYN_SRLV,DYN_SRAV,
							DYN_JR,DYN_JALR,DYN_XX,DYN_XX,DYN_SYSC,DYN_BREAK,DYN_XX,DYN_XX,
							DYN_MFHI,DYN_MTHI,DYN_MFLO,DYN_MTLO,DYN_XX,DYN_XX,DYN_XX,DYN_XX,
							DYN_MUL,DYN_MULU,DYN_DIV,DYN_DIVU,DYN_XX,DYN_XX,DYN_XX,DYN_XX,
							DYN_ADD,DYN_ADDU,DYN_SUB,DYN_SUBU,DYN_AND,DYN_OR,DYN_XOR,DYN_NOR,
							DYN_XX,DYN_XX,DYN_SLT,DYN_SLTU,DYN_XX,DYN_XX,DYN_XX,DYN_XX,
							DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,
							DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX};

void (*dyn_regimm[32])(void)={	DYN_BLTZ,DYN_BGEZ,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,
							DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,
							DYN_BLTZAL,DYN_BGEZAL,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,
							DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX};

void (*dyn_cop0[32])(void)={DYN_C0_MFC,DYN_XX,DYN_XX,DYN_XX,DYN_C0_MTC,DYN_XX,DYN_XX,DYN_XX,
						DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,
						DYN_C0_RFE,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,
						DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX};

void DYN_SPEC() 	{dyn_special[opc&63]();}
void DYN_REGM() 	{dyn_regimm[rt]();}
void DYN_CP0()	{dyn_cop0[rs]();}

void (*dyn_normal[64])(void)={	DYN_SPEC,DYN_REGM,DYN_J,DYN_JAL,DYN_BEQ,DYN_BNE,DYN_BLEZ,DYN_BGTZ,
							DYN_ADDI,DYN_ADDIU,DYN_SLTI,DYN_SLTIU,DYN_ANDI,DYN_ORI,DYN_XORI,DYN_LUI,
							DYN_CP0,DYN_XX,DYN_GTE,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,
							DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,
							DYN_LB,DYN_LH,DYN_LWL,DYN_LW,DYN_LBU,DYN_LHU,DYN_LWR,DYN_XX,
							DYN_SB,DYN_SH,DYN_SWL,DYN_SW,DYN_XX,DYN_XX,DYN_SWR,DYN_XX,
							DYN_XX,DYN_XX,DYN_LWC2,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX,
							DYN_XX,DYN_XX,DYN_SWC2,DYN_XX,DYN_XX,DYN_XX,DYN_XX,DYN_XX};
