#include "sope.h"
#include "machine.h"
#include "../dyn_ops.h"

void (*ahead)();

int put_in_reg(opsize *dest,int r,uint32 what) {
int i;
dest[0]=0xB8+r;
for (i=0;i<4;i++) dest[i+1]=(what>>(i*8))&0xff;
return(5);
}

void byebye() {
    load_imm32(_pc0,0);
    m_mov_to_ctx(0,ktw);
    alphaptr[n++]=int_ret;
    printf("bye bye written\n");
}

int save_counter(opsize *dest) {
	int i;
	dest[0]=0x89;
	dest[1]=0x80+RC+(RN<<3);
	for (i=0;i<4;i++) dest[2+i]=(knstp>>(i*8))&0xff;
	return(6);
}

int load_counter(opsize *dest) {
	int i;
	dest[0]=0x8B;
	dest[1]=0x80+RC+(RN<<3);
	for (i=0;i<4;i++) dest[2+i]=(knstp>>(i*8))&0xff;
	return(6);
}
opsize *header_to;
void make_header() {
    int p,m;
	p=0;
	header[p++]=int_pusha;
    m=put_in_reg(header+p,RC,CTX);p+=m;
	m=load_counter(header+p);p+=m;
	header_to=header+p;
    for (m=0;m<5;m++) header[p+m]=0xff;
    p+=5;
	m=save_counter(header+p);p+=m;
    header[p++]=int_popa;
	header[p++]=int_ret;
}

void go_header(ptsize address) {
    load_adress(header_to,address);
    ahead=(void *)header;
    (*ahead)();
}

void recompile_inst() {
int i,j;

for (i=(bra_nb-1);i>-1;i--) {
	if (_pc0==bra_mips[i]) {
		put_branch_to_at((uint32)alphaptr,bra_alpha[i],cond_ne);
		for (j=i+1;j<bra_nb;j++) {
			bra_mips[j-1]=bra_mips[j];
			bra_alpha[j-1]=bra_alpha[j];
		}
		bra_nb--;
	}
}
opc=getopc(_pc0);

m_add_ri(RN,1);
if (_pc0==halt_address) byebye();
dyn_normal[opc>>26]();
}
void recompile_block(uint32 addr) {

    _pc0=addr;
    stop_recompile=0;
	bra_nb=0;
    do {
        n=0;
		alphad(_pc0)=(ptsize)alphaptr;
        recompile_inst();
	    alphaptr+=n;
	    if (((ptsize)alphaptr-(ptsize)alphacode)>(SIZE_DYN-1000)) ciao("too many instructions!!");
	    _pc0+=4;
	} while (stop_recompile==0);
}

int load_adress(opsize *dest,ptsize am) {
int i;
int diff;
ptsize dd;

dd=(ptsize)dest+5;
diff=am-dd;
dest[0]=0xE8;
for (i=0;i<4;i++) dest[1+i]=(diff>>(i*8))&0xff;
return(5);
}

void reset_dynarec() {
	long i;

	printf("Initializing dynarec core\n");
	alphaptr=alphacode;
	ctx.mptr=(ptsize)mmp;
	for (i=0;i<0xA0000;i++) realcode[i]=0;
	for (i=0;i<0x10000;i++) mmp[i]=(ptsize)CAC;
	for (i=0;i<0x80;i++) {
		mmp[0x0000+i]=(ptsize)RAOM+0x10000*(i&0x1f);
		mmp[0x8000+i]=(ptsize)RAOM+0x10000*(i&0x1f);
		mmp[0xa000+i]=(ptsize)RAOM+0x10000*(i&0x1f);
	}
   for (i=0;i<8;i++) mmp[0xbfc0+i]=(ptsize)RAOM+0x200000+0x10000*i;
	mmp[0x1f00]=(ptsize)PAR;
	mmp[0x1f80]=(ptsize)HRM;
	make_header();
}
