#define get_colors(n,s,c) for (i=0;i<n;i++) c[i]=pak[s*i]&0xffffff;
#define FOR_FS	2
#define FOR_GS	4
#define FOR_FST 4 
#define FOR_GST 6
void get_coords(int n,int s,sint16 *x,sint16 *y) {
int i;

for (i=0;i<n;i++) {
   x[i]=sspak(s*i+2)+gs.ofs_x;
   y[i]=sspak(s*i+3)+gs.ofs_y;
}
}

void get_texture(int n,int tt,texture *t) {
	int i;
	uint32 tpage;

	for (i=0;i<n;i++) {
		t->u[i]=pak[(2+tt)*i+2]&0xff;
		t->v[i]=(pak[(2+tt)*i+2]>>8)&0xff;
	}
	tpage=pak[4+tt]>>16;
	t->clux=(pak[2]>>12)&0x3f0;
	t->cluy=pak[2]>>22;
	t->tx_pal=(tpage>>7)&3;
	t->texx=(tpage&0xf)*64;
	t->texy=((tpage>>4)&1)*256;
}
