#ifndef PLUGINS_H
#define PLUGINS_H

typedef enum Param_Type {boolean,integer} Param_Type;

typedef struct Config_Param{
	Param_Type type;
	char *name;
	int value;
} Config_Param;

typedef struct Config_List{
	int nb;
	Config_Param *params;
} Config_List;

void list_renderer_plugins(void (*fonc)());
void list_sound_plugins(void (*fonc)());
int  load_renderer_plugin(char *filename,char *result);
int  load_sound_plugin(char *filename,char *result);

#endif
