#include <string.h>
#include "null.h"
#include "keyboard.h"

Config_List null_config_list={0,NULL};

Renderer null_renderer = {
	"Null graphic renderer (used for benchmarking)",
	&null_config_list,
	null_start,
	null_init,
	null_exit,
	null_open_window,
	null_close_window,
	null_FSline,
	null_GSline,
	null_FSpoly3,
	null_GSpoly3,
	null_FSpoly4,
	null_GSpoly4,
    null_FSTpoly3,
    null_GSTpoly3,
    null_FSTpoly4,
    null_GSTpoly4,
    null_render_sprite,
    null_blockfill,
	null_rectangle,
	null_clear_texture_cache,
	null_render_frame,
	null_set_scissor,
	null_set_blending,
	null_change_title,
	null_key_pressed,
	null_get_key
};

Renderer *get_renderer_info() {
	return &null_renderer;
}

void null_start(gpu_state *gs,uint32 *vr) {
	gps=gs;
	vram=vr;
}

void null_set_scissor() {
}

void null_set_blending() {
}


void null_init() {
}

void null_open_window(unsigned int w,unsigned int h) {
}
void null_close_window() {
}

void null_exit() {
}
void null_change_title(char *title) {
	printf("%s\n",title);
}

void null_render_frame() {
}

int null_key_pressed() {
	return NO_KEY;
}

uint16 null_get_key() {
	return KEY_INVALID;
}

void null_clear_texture_cache(){ 
}
