#include <GL/gl.h>
#include <GL/glx.h>
#include "sope.h"
#include "renderer.h"
#include "vram.h"

#define glw	1024
#define	glh	512

#define adj_w(n) (int)((n)*(g_width/(cur_width*1.0)))
#define adj_h(n) (int)((n)*(g_height/(cur_height*1.0)))

//#define adj_h(n) (n*g_height)/height
//#define adj_w(n) (n*g_width)/width

int tw64,th64;
uint32 txt[65536];

void ogl_FSline(fs_line *prim);
void ogl_GSline(gs_line *prim);
void ogl_FSpoly3(fs_triangle *prim);
void ogl_GSpoly3(gs_triangle *prim);
void ogl_FSpoly4(fs_quadrangle *prim);
void ogl_GSpoly4(gs_quadrangle *prim);
void ogl_FSTpoly3(fst_triangle *prim);
void ogl_GSTpoly3(gst_triangle *prim);
void ogl_FSTpoly4(fst_quadrangle *prim);
void ogl_GSTpoly4(gst_quadrangle *prim);

void ogl_render_sprite(sprite *prim);
void ogl_blockfill(block *prim);
void ogl_rectangle(block *prim);

void ogl_start(gpu_state *gs,uint32 *vr);
void ogl_open_window(unsigned int w,unsigned int h);
void ogl_close_window();
void ogl_init();
void ogl_exit();
void ogl_clear_texture_cache();
void ogl_render_frame();
void ogl_set_scissor();
void ogl_set_blending();
void ogl_change_title();
int  ogl_key_pressed();
uint16 ogl_get_key();

gpu_state *gps;
uint32 *vram;
int max_vpw,max_vph;
int g_width,g_height;
