	int i;
	float fx,fy;
	uint8 *c;

	if (prim->t) glEnable(GL_BLEND);
	else		 glDisable(GL_BLEND);

	glEnable(GL_SCISSOR_TEST);
	glAlphaFunc(GL_NOTEQUAL,0.0);
	glEnable(GL_ALPHA_TEST);
#ifdef GOURAUD
	glShadeModel(GL_SMOOTH);
	c=(uint8 *)(prim->c);
#else
	glShadeModel(GL_FLAT);
	c=(uint8 *)(&(prim->c));
	glColor4ub(c[0],c[1],c[2],0xff);
#endif

/**/
#if (N==3)
	glBegin(GL_TRIANGLE_STRIP);
#else
	glBegin(GL_QUAD_STRIP);
#endif
	for (i=0;i<N;i++) {
		fx=(prim->x[i]*2.0/glw)-1.0;
		fy=1.0-(prim->y[i]*2.0/glh);
#ifdef GOURAUD
		glColor4ub(c[4*i],c[4*i+1],c[4*i+2],0xff);
#endif
		glVertex2f(fx,fy);
	}
	glEnd();

	glDisable(GL_SCISSOR_TEST);
	glDisable(GL_ALPHA_TEST);
