#define tthi(c)     ((((c)&0xf8)>>3)\
                    +(((c)&0xf800)>>6)\
                    +(((c)&0x1f80000)>>9))

#define hitt(c)     ((((c)&0x1f)<<3)\
                    +(((c)&0x3e0)<<6)\
                    +(((c)&0xec00)<<9)\
                    +0xff000000*((c)>>15))

/*
#define vram4(i)    ((tthi(vram[(i)>>2])>>(((i)&3)<<2))&0xf)
#define vram8(i)    ((tthi(vram[(i)>>1])>>(((i)&1)<<3))&0xff)
*/

// access to 4-bit stuff in vram
static inline uint8 vram4(unsigned int vpos) {
    short unsigned c;
    char unsigned d;
    if (vpos>0x200000) return(0);
    c=tthi(vram[vpos/4]);
    d=(c>>((vpos&3)*4))&0xf;
    return(d);
}

// access to 8-bit stuff in vram
static inline uint8 vram8(unsigned int vpos) {
    short unsigned c;
    char unsigned d;
    if (vpos>0x100000) return(0);
    c=tthi(vram[vpos/2]);
    d=(c>>((vpos&1)*8))&0xff;
    return(d);
}

