/*

	 VAG-Depack, hacked by bITmASTER@bigfoot.com
	 V0.1
*/
#include "sope.h"
double f[5][2] = { { 0.0, 0.0 },
						{	60.0 / 64.0,0.0 },
						{115.0 / 64.0, -52.0 / 64.0 },
						{	98.0 / 64.0, -55.0 / 64.0 },
						{122.0 / 64.0, -60.0 / 64.0 } };

double samples[28];

int vag_depack(uint16 *entree, sint16 *sortie ) {
	uint8 *p;
	uint8 *q;
	int predict_nr, shift_factor, flags;
	int i;
	int d, s;
	static double s_1 = 0.0;
	static double s_2 = 0.0;
	int taille;

	p=(uint8 *)entree;
	q=(uint8 *)sortie;
	taille=0;
	while( 1 ) {
		predict_nr = *p++;
		shift_factor = predict_nr & 0xf;
		predict_nr >>= 4;
		flags = *p++; 
		if ( flags == 7 )
				break;	
		if (flags ==3)
			break;
		if (flags ==4)
			break;
		if (flags ==6)
			            break;
		for ( i = 0; i < 28; i += 2 ) {
				d = *p++;
				s = ( d & 0xf ) << 12;
				if ( s & 0x8000 )
					 s |= 0xffff0000;
				samples[i] = (double) ( s >> shift_factor);
				s = ( d & 0xf0 ) << 8;
				if ( s & 0x8000 )
					 s |= 0xffff0000;
				samples[i+1] = (double) ( s >> shift_factor);
		}

		for ( i = 0; i < 28; i++ ) {
				samples[i] = samples[i] + s_1 * f[predict_nr][0] + s_2 * f[predict_nr][1];
				s_2 = s_1;
				s_1 = samples[i];
				d = (int) ( samples[i] + 0.5 );
				*q++=(d & 0xff);
				*q++=(d >> 8);
				taille++;
				if (taille==65536) return(taille);
		}
	}
return(taille);
}

