#include        <syscall.h>
#include        <psxtypes.h>
#include        <int.h>
#include        <gpu.h>

#define OT_LENGTH       5

GsOT_TAG zSortTable[1<<OT_LENGTH];
PACKET cmdBuffer[3000];

int main()
{
GsOT ot;
LINE line1;
QUAD quad1;
COLOR clr_color = {0, 0,0, 0};

ot.length = OT_LENGTH;
ot.org = zSortTable;

INT_SetUpHandler();

GPU_SetPAL(1);
GPU_Reset(0);
GPU_Init(320, 240, GsNONINTER, 0);
GPU_DefDispBuff(0, 0, 0, 0);

GPU_EnableDisplay(1);

GPU_ClearOt(0, 0, &ot);
GPU_SetCmdWorkSpace(cmdBuffer);
GPU_SortClear(1, &ot, &clr_color);

printf ("Display Enabled OK\n");

line1.color.r = 255;
line1.color.g = 255;
line1.color.b = 255;
line1.vert0.x = 100;
line1.vert0.y = 100;
line1.vert1.x = 200;
line1.vert1.y = 200;

GPU_SortLine(&ot,10,&line1);

GPU_DrawOt(&ot);
GPU_DrawSync();
GPU_FlipDisplay();

printf ("Line OK\n");

quad1.color.r=200;
quad1.color.g=200;
quad1.color.b=200;
quad1.vert0.x=50;
quad1.vert0.y=60;
quad1.vert1.x=300;
quad1.vert1.y=50;
quad1.vert2.x=290;
quad1.vert2.y=220;
quad1.vert3.x=10;
quad1.vert3.y=200;

GPU_SortQuad (&ot,10,&quad1);

GPU_DrawOt(&ot);
GPU_DrawSync();
GPU_FlipDisplay();

printf ("Quad OK\n");
for (;;)
{
}
}


