#include "sope.h"
#include "machine.h"
#include "syscall.h"
#include "pad.h"

void checkstop(uint32 addr,uint32 addr2);

void dyn_handle_flow() {
	if (cd_int) {
		ctx.cp0[13]=0x400;
		ctx.cp0[12]&=0xfffffffe;
		ctx.cp0[14]=ctx.pc0;
		ctx.pc0=0x80;
		HRM(0x1070)|=4;
		cd_int=0;
	}
//	get_pad_buf();
	if (ctx.nstp>ncyc) {
		ctx.nstp=0;
		if ((enable_vsync) && (ctx.cp0[12]&1)) {
			redrawframe();
			HRM(0x1070)|=1;
//			HRM(0x1070)|=0x20;
			ctx.cp0[13]=0x400;
			ctx.cp0[12]&=0xfffffffe;
			ctx.cp0[14]=ctx.pc0;
			ctx.pc0=0x80;
			get_pad_buf();
		}
	}
	checkstop(ctx.pc0,halt_address);
	switch (ctx.pc0) {
	case 0xffffffff: ciao("Break Occured");
	case 0x000000a0: syscall_a0(ctx.gpr[9]);break;
	case 0x000000b0: syscall_b0(ctx.gpr[9]);break;
	case 0x000000c0: syscall_c0(ctx.gpr[9]);break;
	}
 
	if (alphad(ctx.pc0)==0){
//		printf("Compiling from %8.8x\n",ctx.pc0);
		recompile_block(ctx.pc0);
	}
//	printf("Now running from %8.8x after %u cycles\n",ctx.pc0,ctx.nstp);
	go_header(alphad(ctx.pc0));
}

