#include "sope.h"
#include "machine.h"

void DYN_DIV() {
LOAD_REG(rs,EAX);
LOAD_REG(rt,1);
m_mov_rr(EAX,EDX);
m_sar_ri(EDX,31);
//m_xor_rr(EDX,EDX);
m_sdiv(1);
m_mov_to_ctx(EAX,klo);
m_mov_to_ctx(EDX,khi);
}

void DYN_DIVU() {
LOAD_REG(rs,EAX);
LOAD_REG(rt,1);
m_xor_rr(EDX,EDX);
m_udiv(1);
m_mov_to_ctx(EAX,klo);
m_mov_to_ctx(EDX,khi);
}

void DYN_MULU() {
/* LOHI=gpr[rs]*gpr[rt];*/
//printf("MULU %8.8x\n",_pc0);
//ciao("");
LOAD_REG(rs,EAX);
LOAD_REG(rt,1);
m_umul(1);
m_mov_to_ctx(EAX,klo);
m_mov_to_ctx(EDX,khi);
}

void DYN_MUL() {
//printf("MUL %8.8x\n",_pc0);
//ciao("");
LOAD_REG(rs,EAX);
LOAD_REG(rt,1);
m_smul(1);
m_mov_to_ctx(EAX,klo);
m_mov_to_ctx(EDX,khi);
}

void DYN_MFHI() {
m_mov_from_ctx(0,khi);
SAVE_REG(rd,0);
}
void DYN_MFLO() {
m_mov_from_ctx(0,klo);
SAVE_REG(rd,0);
}
void DYN_MTHI() {
LOAD_REG(rs,0);
m_mov_to_ctx(0,khi);
}
void DYN_MTLO() {
LOAD_REG(rs,0);
m_mov_to_ctx(0,klo);
}
