#include <string.h>
#include "sope.h"
#include "gui.h"
#include "fileio.h"

void loadexec(char *fn) {
	FILE *g;
	EXE_HEADER exh;
	int unsigned pipi[512];

	g=fopen(fn,"r");
	sprintf(distring,"Loading exec %s",fn);
	gui->print(distring);
	if (g==NULL) ciao("Not found");
	fread(pipi,4,512,g);
	memmove(&exh,pipi,4*18);
	fread(RAOM+((END_32(exh.t_addr)) & (0x001fffff)),1,END_32(exh.t_size),g);
	ctx.pc0=END_32(exh.pc0);
	ctx.gpr[28]=END_32(exh.GP0);
	ctx.gpr[29]=END_32(exh.s_size);
	
	fclose(g);
}

void loaddata(char *fn,int unsigned start) {
	FILE *g;
	int signed i;

	sprintf(distring,"Loading data %s at 0x%8.8x",fn,start);
	gui->print(distring);
	g=fopen(fn,"r");
	if (g==NULL) ciao("Not found");
	i=-4;
	do  {i+=4;} while (fread(RAOM+((start) & (0x001fffff))+i,4,1,g)==1);
	fclose(g);
}

void loadpll(char *fn) {
	FILE *g;
	char prems[8];
	char fifi[100];
	int unsigned dodo;
	
	g=fopen(fn,"r");
	if (g==NULL) ciao("PLL file not found");
	
	g=fopen(fn,"r");
	fscanf(g,"%s",prems);
	do {
	if (strncmp(prems,"DATA",4)==0) {
	   fscanf(g,"%s",fifi);
	   fscanf(g,"%x",&dodo);
	   loaddata(fifi,dodo);
	}
	if (strncmp(prems,"LOAD",4)==0) {
	   fscanf(g,"%s",fifi);
	   loadexec(fifi);
	}
	if (strncmp(prems,"SETPC",5)==0) {
	   fscanf(g,"%x",&dodo);
	   sprintf(distring,"Setting pc0 at 0x%8.8x",dodo);
	   gui->print(distring);
	   ctx.pc0=dodo;
	}
	fscanf(g,"%s",prems);
	}
	while (!feof(g)); 
	fclose(g);
}

void loadanyfile(char *fn) {
	FILE *g;
	int cc;

	g=fopen(fn,"r");
	if (g==NULL) ciao("File not found");
	cc=fgetc(g);
	fclose(g);
	if (cc==80) {loadexec(fn);return;}
	if ((cc==68) || (cc==76) || (cc==83)) {loadpll(fn);return;}
	ciao("File is not valid");
}

