int width,height;

void initscreen(char unsigned gmode) {
   
	height=240*(1+((gmode&4)>>2));
	if (force_pal) height=256*(1+((gmode&4)>>2));
	switch (gmode&3)  {
	case 0: width=256;break;
	case 1: width=320;break;
	case 2: width=512;break;
	case 3: width=640;break;
	}

	if ((gmode&0x40)!=0) width=368;
	if (screen_mode!=gmode) {
		if (debug_gpu) printf("# Sope # gmode=%2.2x --> Opening %u x %u Window\n",gmode,width,height);
		if (screen_mode==0xff)	rnd->init();
		else rnd->close_window();
		rnd->open_window(width,height);
		screen_mode=gmode;
	}
}

#include <sys/time.h>

void redrawframe() {
	static struct timeval tvi;
	struct timeval tvf;
	static long nf = 0;
	float titi;
	char titre[256];

	if (screen_mode==0xff) return;
	if (dsp_changed==0) return;
	gettimeofday(&tvf,0);
	titi=(tvf.tv_sec-tvi.tv_sec)+(tvf.tv_usec-tvi.tv_usec)/1000000.0;
	if (titi>1.0) {
		tvi=tvf;
		sprintf(titre,"Sope -- %ux%u -- %.1f FPS",width,height,nf/titi);
		rnd->change_title(titre);
		nf=0;
		}
	nf++;
	dsp_changed=0;
	if (norender) return;
	rnd->render_frame();
}
