void draw_blockfill(){
	block rect;

	rect.x=sspak(2);
	rect.y=sspak(3);
	rect.w=sspak(4);
	rect.h=sspak(5);
	rect.c=pak[0]&0xFFFFFF;
	rect.t=0;

	if (debug_poly) printf("block fill  x,y:%d,%d w,h:%d,%d\n",rect.x,rect.y,rect.w,rect.h);
	rnd->blockfill(&rect);
}

void draw_fs_triangle(int p){
	fs_triangle tri;

	get_coords(3,FOR_FS,tri.x,tri.y);
	tri.c=pak[0]&0xffffff;
	tri.t=p;
	rnd->FSpoly3(&tri);
}

void draw_gs_triangle(int p){
	gs_triangle tri;
	int i;

	get_colors(3,2,tri.c);
	get_coords(3,FOR_GS,tri.x,tri.y);
	tri.t=p;
	rnd->GSpoly3(&tri);
}

void draw_fs_quadrangle(int p){
fs_quadrangle quad;

get_coords(4,FOR_FS,quad.x,quad.y);
quad.c=pak[0]&0xFFFFFF;
quad.t=p;
if ((quad.x[0]==quad.x[2]) && (quad.x[1]==quad.x[3]) && (quad.y[0]==quad.y[1]) && (quad.y[2]==quad.y[3]) && (quad.t==0))  {
	pak[2]=(quad.x[1]-quad.x[0]) + (quad.y[2]-quad.y[0])*0x10000;
	draw_blockfill();
	return;
}
rnd->FSpoly4(&quad);
}

void draw_gs_quadrangle(int p){
	gs_quadrangle quad;
	int i;

	get_colors(4,2,quad.c);
	get_coords(4,FOR_GS,quad.x,quad.y);
	quad.t=p;
	rnd->GSpoly4(&quad);
}

void draw_fst_triangle(int p,int m){
	fst_triangle tri;

	get_coords(3,FOR_FST,tri.x,tri.y);
	get_texture(3,0,&(tri.tex));
	tri.c=pak[0]&0xffffff;
	tri.t=p;
	tri.m=m;
	rnd->FSTpoly3(&tri);
}


void draw_gst_triangle(int p,int m){
	gst_triangle tri;
	int i;

	get_colors(3,3,tri.c);
	get_coords(3,FOR_GST,tri.x,tri.y);
	get_texture(3,1,&(tri.tex));
	tri.t=p;
	tri.m=m;
	rnd->GSTpoly3(&tri);
}

void draw_fst_quadrangle(int p,int m){
	fst_quadrangle quad;

	get_coords(4,FOR_FST,quad.x,quad.y);
	get_texture(4,0,&(quad.tex));
	quad.c=pak[0]&0xffffff;
	quad.t=p;
	quad.m=m;
	rnd->FSTpoly4(&quad);
}

void draw_gst_quadrangle(int p,int m){
	gst_quadrangle quad;
	int i;

	get_colors(4,3,quad.c);
	get_coords(4,FOR_GST,quad.x,quad.y);
	get_texture(4,1,&(quad.tex));
	quad.t=p;
	quad.m=m;
	rnd->GSTpoly4(&quad);
}

