/*BERK: re-implement this, too slow*/
#include <math.h>
#define IGNORE_OPC 1
#include "sope.h"
#undef IGNORE_OPC
#include "gte_defs.h"

void gte_dpcl()
{
	ciao("GTE DPCL Not implemented yet");
}

void gte_dpcs()
{
	ciao("GTE DPCS Not implemented yet");
}

void gte_dpct()
{
	ciao("GTE DPCT Not implemented yet");
}

void gte_intpl()
{
	ciao("GTE INTPL Not implemented yet");
}

void gte_ncs()
{
	ciao("GTE NCS Not implemented yet");
}

void gte_nct()
{
	ciao("GTE NCT Not implemented yet");
}

void gte_cc()
{
	ciao("GTE CC Not implemented yet");
}

void gte_cdp()
{
	ciao("GTE CDP Not implemented yet");
}

void gte_op()
{
	ciao("GTE OP Not implemented yet");
}

void gte_avsz4()
{
	double OOTZ;
	OOTZ =
		(ZSF4 / 4096.0) * SZ(0) + (ZSF4 / 4096.0) * SZ(1) +
		(ZSF4 / 4096.0) * SZ(2) + (ZSF4 / 4096.0) * SZ(3);
	OTZ = Lm_D(OOTZ);
	MAC(0) = Lm_F(OOTZ);
}

void gte_avsz3()
{
	double OOTZ;
	OOTZ =
		(ZSF3 / 4096.0) * SZ(1) + (ZSF3 / 4096.0) * SZ(2) +
		(ZSF3 / 4096.0) * SZ(3);
	OTZ = Lm_D(OOTZ);
	MAC(0) = Lm_F(OOTZ);
}

void gte_nclip()
{
	int OPZ;
	OPZ =
		SX(0) * SY(1) + SX(1) * SY(2) + SX(2) * SY(0) - SX(0) * SY(2) -
		SX(1) * SY(0) - SX(2) * SY(1);
	MAC(0) = OPZ;
}

void gte_gpf(int f)
{
	double IP[4];
	int i;

	if (debug_gte)
		printf("# Sope # GPF\n");
/*T-REX: 5%*/
	if (f == 1) {
		for (i = 1; i < 4; i++) {
			IP[i] = IR(0) * (IR(i) / 4096.0);
			IR(i) = Lm_B(IP[i], 0, i);
			MAC(i) = Lm_A(IP[i], i);
		}
	} else {
		for (i = 1; i < 4; i++) {
			IP[i] = IR(0) * (IR(i));
			IR(i) = Lm_B(IP[i], 0, i);
			MAC(i) = Lm_A(IP[i], i);
		}
	}


	_CD_(0) = _CD_(1);
	_CD_(1) = _CD_(2);
	_CD_(2) = CODE;
	_R_(0) = _R_(1);
	_R_(1) = _R_(2);
	_R_(2) = Lm_C(IP[1], 1);
	_G_(0) = _G_(1);
	_G_(1) = _G_(2);
	_G_(2) = Lm_C(IP[2], 2);
	_B_(0) = _B_(1);
	_B_(1) = _B_(2);
	_B_(2) = Lm_C(IP[3], 3);
}

void gte_gpl()
{
	double IP[4];
	int i;

	if (debug_gte)
		printf("# Sope # GPL\n");
	for (i = 1; i < 4; i++) {
		IP[i] = MAC(i) + IR(0) * (IR(i) / 4096.0);
		IR(i) = Lm_B(IP[i], 0, i);
		MAC(i) = Lm_A(IP[i], i);

	}

	_CD_(0) = _CD_(1);
	_CD_(1) = _CD_(2);
	_CD_(2) = CODE;
	_R_(0) = _R_(1);
	_R_(1) = _R_(2);
	_R_(2) = Lm_C(IP[1], 1);
	_G_(0) = _G_(1);
	_G_(1) = _G_(2);
	_G_(2) = Lm_C(IP[2], 2);
	_B_(0) = _B_(1);
	_B_(1) = _B_(2);
	_B_(2) = Lm_C(IP[3], 3);
}

void gte_sqr()
{
	double L[4];
	int i;
	if (debug_gte)
		printf("# Sope # SQR\n");
	for (i = 1; i < 4; i++) {
		L[i] = IR(i) * IR(i);
		IR(i) = Lm_B(L[i], 1, i);
		MAC(i) = Lm_A(L[i], i);
	}
}


#include "gte_alg.h"
#include "gte_cc.h"

void doirgb()
{
	uint32 irgb;
	irgb = IRGB;
	ORGB =
		((IR(3) >> 7) & 0x1f) + 0x20 * ((IR(2) >> 7) & 0x1f) +
		0x400 * ((IR(1) >> 7) & 0x1f);
	IR(1) = ((irgb >> 10) & 0x1f) << 4;
	IR(2) = ((irgb >> 5) & 0x1f) << 4;
	IR(3) = (irgb & 0x1f) << 4;
}

uint32 dolzc()
{
	int j;
	uint32 lzcs;

	j = 32;
	lzcs = LZCS;
	if (S_LZCS < 0)
		lzcs ^= 0xFFFFFFFF;
	do {
		if ((LZCS >> (32 - j)) == 0)
			return (j);
		j--;
	} while (j != 0);
	return (0);
}

void gte_opcode(uint32 opc)
{

	switch (rs) {
	/* mfc1*/ case 0:
		if (rd == 31)
			LZCR = dolzc();
		ctx.gpr[rt] = ctx.gte1[rd];
		return;
	/* mfc2*/ case 2:
		ctx.gpr[rt] = ctx.gte2[rd];
		return;
	/* mtc1*/ case 4:
		ctx.gte1[rd] = ctx.gpr[rt];
		if (rd == 28)
			doirgb();
		return;
	/* mtc2*/ case 6:
		ctx.gte2[rd] = ctx.gpr[rt];
		return;
	/*mvmva*/ case 18:
		FLAG = 0;
		gte_mvmva(opc);
		return;
	}

	FLAG = 0;
//printf("GTE %x\n",opc&0x1ffffff);
	switch (opc & 0x1ffffff) {

	case 0x0180001:
		gte_rtps();
		break;
	case 0x0280030:
		gte_rtpt();
		break;
	case 0x0680029:
		gte_dpcl();
		break;
	case 0x0780010:
		gte_dpcs();
		break;
	case 0x0F8002A:
		gte_dpct();
		break;
	case 0x0980011:
		gte_intpl();
		break;
	case 0x0A00428:
		gte_sqr();
		break;
	case 0x0C8041E:
		gte_ncs();
		break;
	case 0x0D80420:
		gte_nct();
		break;

	case 0x0E80413:
		gte_ncds();
		break;
	case 0x0F80416:
		gte_ncdt();
		break;

	case 0x108041B:
		gte_nccs();
		break;
	case 0x118043F:
		gte_ncct();
		break;
	case 0x1280414:
		gte_cdp();
		break;
	case 0x138041C:
		gte_cc();
		break;
	case 0x1400006:
		gte_nclip();
		break;
	case 0x158002D:
		gte_avsz3();
		break;
	case 0x168002E:
		gte_avsz4();
		break;
	case 0x170000C:
		gte_op();
		break;
	case 0x190003d:
		gte_gpf(0);
		break;
	case 0x198003d:
		gte_gpf(1);
		break;
	case 0x1a8003e:
		gte_gpl();
		break;
	default:
		printf("# Sope # %u: %x unknown GTE command\n", (opc >> 21) & 31,
			   opc & 0x1ffffff);
		exit(0);
	}
}
