#include "sope.h"
#include "hwr.h"

uint32 stat;

void mdec_reset() {
stat = 0;
}


uint32 mdec_readstat() {
//printf ("readstat %x\n",stat);
return stat;
}


void mdec_writestat(uint32 data) {
//printf ("writestat %x\n",data);
if (data & 0x80000000) mdec_reset();
}


void mdecindma() {
uint32 size,addr,dma3;
int i;

size = HRM32(mdecin_bcr);
addr = HRM32(mdecin_madr);
dma3 = HRM32(mdecin_chcr);
addr &= 0x1fffff;
size = (size & 0xffff) * (size >> 16);

if (dma3 == 0) {
stat = 0;
return;
}

/*for (i=0;i<size;i++) printf ("%2.2x ",RAOM[addr+i]);
printf ("\n");*/

HRM32(mdecin_chcr) &= 0xfeffffff;
HRM32(i_reg) |= 8;
HRM32(0x10f4) = 0x01000000;

printf ("dma mdecin size,%8.8x,addr=%8.8x,dma3=%8.8x\n",size,addr,dma3);
}


void mdecoutdma() {
uint32 size,addr,dma3;

size = HRM32(mdecout_bcr);
addr = HRM32(mdecout_madr);
dma3 = HRM32(mdecout_chcr);

if (dma3 == 0) {
stat = 0;
return;
}

HRM32(mdecout_chcr) &= 0xfeffffff;
HRM32(i_reg) |= 8;
HRM32(0x10f4) = 0x02000000;

printf ("dma mdecout size,%8.8x,addr=%8.8x,dma3=%8.8x\n",size,addr,dma3);
}