#include "sope.h"
#include "renderer.h"
#include "keyboard.h"

const uint16 keys[16] = {
    KEY_3,   /*R2*/
    KEY_e,   /*R1*/
    KEY_1,   /*L2*/
    KEY_q,   /*L1*/
    KEY_w,   /*Triangle*/
    KEY_d,   /*Circle*/
    KEY_x,   /*Cross*/
    KEY_a,   /*Square*/
    KEY_SPACE,/*Select*/
    KEY_z,
    KEY_z,
    KEY_RETURN, /*Start*/
    KEY_UP, /*Up*/
    KEY_RIGHT, /*Right*/
    KEY_DOWN,  /*Down*/
    KEY_LEFT   /*Left*/
};

void screenshot(int s);

void get_pad_buf() {
	int i;
	uint16 k;
	uint8 e;
	uint16 joymask;
	static uint32 JoyState=0xFFFFFFFF;

	if (screen_mode==0xff) return;
	e=rnd->key_pressed();
	if (e!=NO_KEY) {
		k=rnd->get_key();
		if (e==PRESSED_KEY) {
			joymask=0xFFFF;
			for (i=0;i<16;i++) {
				if (k==keys[i]) joymask=0xFFFF-(1<<i);
			}
			if (pad_init==1) JoyState&=0xFFFF0000|joymask;
			if (pad_init==2) JoyState&=0x0000FFFF|((joymask&0xFF)<<24)|((joymask&0xFF00)<<8);
			switch(k) {
			case KEY_F5:	screenshot(1); return;
			case KEY_F6:	screenshot(0); return;
			case KEY_F7:	dass=1-dass; return;
			case KEY_F9:	norender=1-norender;return;
			case KEY_F10:	fast_graph=1-fast_graph;return;
			case KEY_F11:	notextures=1-notextures;return;
			case KEY_F12:	anti_alias=1-anti_alias;return;
			case KEY_ESCAPE:	ciao("Bye!");
			default:break;
			}
		}
		if (e==RELEASED_KEY) {
			joymask=0;
			for (i=0;i<16;i++) {
				if (k==keys[i]) joymask=(1<<i);
			}
			if (pad_init==1) JoyState|=joymask;
			if (pad_init==2) JoyState|=((joymask&0xFF)<<24)|((joymask&0xFF00)<<8);
		}
	}
	RAOM32[ctx.pbuf/4]=END_32(JoyState);
}
