#include "opengl.h"

void ogl_FSline(fs_line *prim) {
int i;

float fx,fy;
char unsigned r,g,b;

if (prim->t) glEnable(GL_BLEND);
else		 glDisable(GL_BLEND);

glEnable(GL_SCISSOR_TEST);

r=(prim->c)&0xff;
g=((prim->c)>>8)&0xff;
b=((prim->c)>>16)&0xff;

glShadeModel(GL_FLAT);
glColor4ub(r,g,b,0xff);
glBegin(GL_LINE_STRIP);
for (i=0;i<2;i++) {
    fx=(prim->x[i]*2.0/glw)-1.0;
    fy=1.0-(prim->y[i]*2.0/glh);
	glVertex2f(fx,fy);
}
glEnd();
glBegin(GL_POINTS);
glVertex2f(fx,fy);
glEnd();

glDisable(GL_SCISSOR_TEST);
}

void ogl_GSline(gs_line *prim) {
float fx,fy;
char unsigned r,g,b;
int i; 

if (prim->t) glEnable(GL_BLEND);
else		 glDisable(GL_BLEND);

glEnable(GL_SCISSOR_TEST);

glShadeModel(GL_SMOOTH);
glBegin(GL_LINE_STRIP);
for (i=0;i<2;i++) {
	r=(prim->c[i])&0xff;
	g=((prim->c[i])>>8)&0xff;
	b=((prim->c[i])>>16)&0xff;
	fx=(prim->x[i]*2.0/glw)-1.0;
	fy=1.0-(prim->y[i]*2.0/glh);
	glEdgeFlag(GL_FALSE);
	glColor4ub(r,g,b,0xff);
	glVertex2f(fx,fy);
}
glEnd();
glBegin(GL_POINTS);
glColor4ub(r,g,b,0xff);
glVertex2f(fx,fy);
glEnd();

glDisable(GL_SCISSOR_TEST);
}

