	int i;
	float fx,fy;
	float tfx,tfy;
	uint8 *c;

//Fix Transparencies!!
	if (prim->t)	glEnable(GL_BLEND);
	else			glDisable(GL_BLEND);
	glEnable(GL_SCISSOR_TEST);
	glEnable(GL_ALPHA_TEST);
//	if (notextures==0) load_texture(&(prim->tex),prim->m);

#ifdef GOURAUD
	glShadeModel(GL_SMOOTH);
	c=(uint8 *)(prim->c);
#else
	glShadeModel(GL_FLAT);
	c=(uint8 *)(&(prim->c));
	glColor4ub(c[0],c[1],c[2],0xff);   
#endif

#if (N==3)
	glBegin(GL_TRIANGLE_STRIP);
#else
	glBegin(GL_QUAD_STRIP);
#endif
	for (i=0;i<N;i++) {
		fx=(prim->x[i]*2.0/glw)-1.0;
		fy=1.0-(prim->y[i]*2.0/glh);
/*Replace tw64 by (tw64-1) to get Sony logo correctly*/
		tfx=(1.0*prim->tex.u[i])/(tw64-1);
		tfy=(1.0*prim->tex.v[i])/(th64-1);
#ifdef GOURAUD
		glColor4ub(c[3*i],c[3*i+1],c[3*i+2],0xff);
#endif
		glTexCoord2f(tfx,tfy);
		glVertex2f(fx,fy);
	}
	glEnd();

/*If no hack possible, do the same thing again*/
	glEnable(GL_BLEND);
	if (prim->t==0) glBlendFunc(GL_ONE,GL_ONE);
	else {if (gps->abr==0) glBlendFunc(GL_CONSTANT_ALPHA,GL_ONE);}
#if (N==3)
	 glBegin(GL_TRIANGLE_STRIP);
#else
    glBegin(GL_QUAD_STRIP);
#endif
	for (i=0;i<N;i++) {
		fx=(prim->x[i]*2.0/glw)-1.0;
		fy=1.0-(prim->y[i]*2.0/glh);
		tfx=(1.0*prim->tex.u[i])/tw64;
		tfy=(1.0*prim->tex.v[i])/th64;
#ifdef GOURAUD
		glColor4ub(c[3*i],c[3*i+1],c[3*i+2],0xff);
#endif
		glTexCoord2f(tfx,tfy);
		glVertex2f(fx,fy);
	}
	glEnd();
	
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_SCISSOR_TEST);
	glDisable(GL_ALPHA_TEST);
