#include "soft.h"

void soft_blockfill(block *prim){
	int i,j,txi,txf,tyi,tyf;
	sint16 x,y,w,h;

	x=prim->x;
	y=prim->y;
	w=prim->w;
	h=prim->h;

	if ((y<(1+gps->oyi-h)) || (x<(1+gps->oxi-w)) || (y>(gps->oyf-1)) || (x>(gps->oxf-1))) return;
	txi=0;txf=w;tyi=0;tyf=h;
	if (y<gps->oyi) tyi=gps->oyi-y;
	if (y>(gps->oyf-h)) tyf=h-(y-(gps->oyf-h));
	if (x<gps->oxi) txi=gps->oxi-x;
	if (x>(gps->oxf-w)) txf=w-(x-(gps->oxf-w));

	for (j=(y+tyi);j<(y+tyf);j++) {
		for (i=(x+txi);i<(x+txf);i++) vram[1024*j+i]=prim->c|gps->_md_;
	}
}

void soft_rectangle(block *prim){
	int i,j,txi,txf,tyi,tyf;
	sint16 x,y,w,h;

	x=prim->x;
	y=prim->y;
	w=prim->w;
	h=prim->h;

	if ((y<(1+gps->oyi-h)) || (x<(1+gps->oxi-w)) || (y>(gps->oyf-1)) || (x>(gps->oxf-1))) return;
	txi=0;txf=w;tyi=0;tyf=h;
	if (y<gps->oyi) tyi=gps->oyi-y;
	if (y>(gps->oyf-h)) tyf=h-(y-(gps->oyf-h));
	if (x<gps->oxi) txi=gps->oxi-x;
	if (x>(gps->oxf-w)) txf=w-(x-(gps->oxf-w));

	for (j=(y+tyi);j<(y+tyf);j++) {
		for (i=(x+txi);i<(x+txf);i++) draw_sumcol(i,j,prim->t,prim->c);
	}
}

