	int x,y,e,trp,x2;
#ifdef GOURAUD
	int mat_g[3][3];
	double out_g[3][3];
	double cur[3];
#endif
#ifdef TEXTURED
	int mat_t[2][3];
	double out_t[2][3];
	double curx,cury;
#endif
#if defined(GOURAUD) || defined(TEXTURED)
	double ad,bd,a1,a2,a3,b1,b2,b3;
	int i;

	ad=((xa[p1]-xa[p0])*(ya[p2]-ya[p0])-(xa[p2]-xa[p0])*(ya[p1]-ya[p0]));
	a1=(ya[p2]-ya[p0])/ad;
	a2=(xa[p0]-xa[p2])/ad;
	a3=-xa[p0]*a1-ya[p0]*a2;
	bd=((xa[p2]-xa[p0])*(ya[p1]-ya[p0])-(xa[p1]-xa[p0])*(ya[p2]-ya[p0]));
	b1=(ya[p1]-ya[p0])/bd;
	b2=(xa[p0]-xa[p1])/bd;
	b3=-xa[p0]*b1-ya[p0]*b2;
#endif
#ifdef GOURAUD
	for( i=0; i<3; i++ ) {
		mat_g[i][0]=(((colors[p1]>>i*8)&255)-((colors[p0]>>i*8)&255));
		mat_g[i][1]=(((colors[p2]>>i*8)&255)-((colors[p0]>>i*8)&255));
		mat_g[i][2]=(colors[p0]>>i*8)&255;
	}
	for( i=0; i<3; i++ ) {
		out_g[i][0]=a1*mat_g[i][0]+b1*mat_g[i][1];
		out_g[i][1]=a2*mat_g[i][0]+b2*mat_g[i][1];
		out_g[i][2]=a3*mat_g[i][0]+b3*mat_g[i][1]+mat_g[i][2];
	}
#endif
#ifdef TEXTURED
	mat_t[0][0]=((short)(tex->u[p1]-tex->u[p0]));
	mat_t[0][1]=((short)(tex->u[p2]-tex->u[p0]));
	mat_t[0][2]=tex->u[p0];

	mat_t[1][0]=((short)(tex->v[p1]-tex->v[p0]));
	mat_t[1][1]=((short)(tex->v[p2]-tex->v[p0]));
	mat_t[1][2]=tex->v[p0];
	for( i=0; i<2; i++ ) {
		out_t[i][0]=a1*mat_t[i][0]+b1*mat_t[i][1];
		out_t[i][1]=a2*mat_t[i][0]+b2*mat_t[i][1];
		out_t[i][2]=a3*mat_t[i][0]+b3*mat_t[i][1]+mat_t[i][2];
	}
#endif
	e=colors[0]&0xFFFFFF;
	sd_init();
	sd_addline(xa[p0],ya[p0],xa[p1],ya[p1]);
	sd_addline(xa[p1],ya[p1],xa[p2],ya[p2]);
	sd_addline(xa[p2],ya[p2],xa[p0],ya[p0]);
	trp=p0;
	if( ya[p1]<ya[trp] || (ya[p1]==ya[trp] && xa[p1]>xa[trp]))
		trp=p1;
	if( ya[p2]<ya[trp] || (ya[p2]==ya[trp] && xa[p2]>xa[trp]))
		trp=p2;
	for( y=MAX(gps->oyi,top); y<MIN(gps->oyf,bottom); y++ ) {
#ifdef GOURAUD
//		double cur[3];
		for( i=0; i<3; i++ )
			cur[i]=MAX(gps->oxi,lpos[y+1])*out_g[i][0]+y*out_g[i][1]+out_g[i][2];
#endif
#ifdef TEXTURED
//		double curx,cury;
		curx=MAX(gps->oxi,lpos[y+1])*out_t[0][0]+y*out_t[0][1]+out_t[0][2];
		cury=MAX(gps->oxi,lpos[y+1])*out_t[1][0]+y*out_t[1][1]+out_t[1][2];
#endif
		x2=computex2(y,xa[trp],ya[trp]);
		for( x=MAX(gps->oxi,lpos[y+1]); x<=x2; x++ ) {
#ifdef TEXTURED
			int tx,ty,ee;
#endif
#ifdef GOURAUD
			e=0;
			for( i=0; i<3; i++ ) {
				int v=cur[i];
				if( v > 255 ) v=255;
				if( v < 0 ) v=0;
				e+=v<<(8*i);
				cur[i]+=out_g[i][0];
			}
			e|=0xFF000000;
#endif
#ifdef TEXTURED
			tx=curx;
			curx+=out_t[0][0];
			ty=MAX(0,cury);/*BERK: hack to avoid segfault*/
			cury+=out_t[1][0];
			switch( tex->tx_pal ) {
			case 0:
				ee=colorarray[vram4((tex->texy+ty)*4096+tex->texx*4+tx)];
				break;
			case 1: 
				ee=colorarray[vram8((tex->texy+ty)*2048+tex->texx*2+tx)];
				break;
			case 2:
				ee=vram[(tex->texy+ty)*1024+(tex->texx+tx)];
				break;
			default:
				ee=0;
				break;
			}
			if( !mocoP )
				ee=moco(ee,e);
			draw_sumcol(x,y,blendP,ee);
#else
			draw_sumcol(x,y,blendP,e);
#endif
		}
	}
