#include "soft.h"

void soft_FSpoly4(fs_quadrangle *prim)
{
	sdf_triangle(prim->x,prim->y,0,1,2,prim->t,&prim->c);
	sdf_triangle(prim->x,prim->y,1,3,2,prim->t,&prim->c);
}

void soft_GSpoly4(gs_quadrangle *prim)
{
	sdg_triangle(prim->x,prim->y,0,1,2,prim->t,prim->c);
	sdg_triangle(prim->x,prim->y,1,3,2,prim->t,prim->c);
}

void soft_FSTpoly4(fst_quadrangle *prim)
{
	if (notextures==0) {
		sd_initcc(&prim->tex,prim->m,prim->c);
		sdft_triangle(prim->x,prim->y,0,1,2,prim->t,&prim->c,prim->m,&prim->tex);
		sdft_triangle(prim->x,prim->y,1,3,2,prim->t,&prim->c,prim->m,&prim->tex);
	} else {
		sdf_triangle(prim->x,prim->y,0,1,2,prim->t,&prim->c);
		sdf_triangle(prim->x,prim->y,1,3,2,prim->t,&prim->c);
	}
}

void soft_GSTpoly4(gst_quadrangle *prim) {
	if (notextures==0) {
		sd_initcc(&prim->tex,prim->m,prim->c[0]);
		sdgt_triangle(prim->x,prim->y,0,1,2,prim->t,prim->c,prim->m,&prim->tex);
		sdgt_triangle(prim->x,prim->y,1,3,2,prim->t,prim->c,prim->m,&prim->tex);
	} else {
		sdg_triangle(prim->x,prim->y,0,1,2,prim->t,prim->c);
		sdg_triangle(prim->x,prim->y,1,3,2,prim->t,prim->c);
	}
}
