/*Clean me up!!!!!*/
#include <stdio.h>

#include "sope_defs.h"
#define SR		((sint32 *)ctx.gpr)

#define PAR32   ((uint32 *)PAR)
#define PAR16	((uint16 *)PAR)
#define SPAR16	((sint16 *)PAR)
#define SPAR	((sint8  *)PAR)

#ifdef GRAND_ENDIAN
/*
#define HRM32(n)    ((uint32 *)HRM)[n]
#define HRM16(n)    ((uint16 *)HRM)[2*((n)/2)+1-(n)%2]
#define HRM(n)      HRM[4*((n)/4)+3-(n)%4]
*/
#define HRM32(n)    ((uint32 *)HRM)[(n)/4]
#define HRM16(n)    ((uint16 *)HRM)[2*((n)/4)+1-((n)/2)%2]
#define HRM(n)      HRM[4*((n)/4)+3-(n)%4]
#else
#define HRM32(n)    ((uint32 *)HRM)[(n)/4]
#define HRM16(n)    ((uint16 *)HRM)[(n)/2]
#define HRM(n)      HRM[n]
#endif

#define RAOM32	((uint32 *)RAOM)
#define RAOM16	((uint16 *)RAOM)
#define SRAOM16	((sint16 *)RAOM)
#define SRAOM	((sint8  *)RAOM)

#define IGTE_R1 ((sint32 *)ctx.gte1)
#define IGTE_R2 ((sint32 *)ctx.gte2)
#define SGTE_R1 ((sint16 *)ctx.gte1)
#define SGTE_R2 ((sint16 *)ctx.gte2)
#define BGTE_R1 ((uint8  *)ctx.gte1)

#ifdef GRAND_ENDIAN
#define sspak(n)	((sint16 *)pak)[2*(n/2)+1-n%2]
#else
#define sspak(n)	((sint16 *)pak)[n]
#endif

#define re ((opc >>  6)&0x1f)
#define rd ((opc >> 11)&0x1f)
#define rt ((opc >> 16)&0x1f)
#define rs ((opc >> 21)&0x1f)
#define imm (opc&0xffff)

#define realofs(adr)	(((adr)<0xbfc00000)?((adr)&0x1fffff):((adr)-0xbfc00000+0x200000))
#define realofs4(adr)	((adr)<0xbfc00000)?(((adr)&0x1fffff)>>2):(((adr)-0xbfc00000+0x200000)>>2)
#define alphad(adr) 	realcode[realofs4(adr)]
#define getaddr(adr)    (RAOM+realofs(adr))

#ifdef GRAND_ENDIAN
#define END_16(val)	({ uint16 x = val; x = (x << 8) | (x >> 8); x; })
#define END_32(val)	({ uint32 x = val; x = (x << 24) | ((x << 8) & 0xff0000) | ((x >> 8) & 0xff00) | (x >> 24); x; })
#define simm ((sint16)opc)
#define getopc(adr)	  END_32(RAOM32[realofs4(adr)])
#else
#define END_16(val)	val
#define END_32(val)	val
#define simm (((sint32)((opc&0xffff)<<16))>>16)
#define getopc(adr) 	RAOM32[realofs4(adr)]
#endif

#include "context.h"
#include "dynrec.h"
/*Playstation Hardware*/
uint8 RAOM[0x280000];
uint8 HRM[0x10000];
uint8 SBF[0x80000];/*SPU Sound Buffer*/
uint8 PAR[0x10000];
uint8 CAC[0x10000];
uint32 glbuf[524288];/*VRAM*/
#ifndef IGNORE_OPC
uint32 opc;
#endif
uint32 _pc0;
context ctx;
int ncyc;			/*Number of cycles between Vsync interrupts*/
long unsigned noi;			/*Number of instructions since last reset*/

int pad_init;		/*Pad Mode ... quick hack*/

int cd_int;
int enable_vsync;

unsigned int debug_mask;
int debug_syscall;
int debug_hwr;
int debug_hre;
int debug_sound;
int debug_dma;
int debug_gpu;
int debug_poly;
int debug_gte;
int debug_cd;
int dass;

/*File loading*/
char distring[128];
/*Functions*/
void handle_flow();
void cd_close();
void cd_boot();
void quit(int signal);
void dasm2();
void bootrom();
void init_sound();
/*misc variables ... to clean up*/
int limite;
int norender;
int notextures;
int anti_alias;
int force_pal;
int dsp_changed;/*Needs a redraw*/
int fast_graph;
int boot_cdrom;
char RENDERER[32];
char SOUND[32];

/*berk*/
float fw,fh;
char unsigned screen_mode;
int unsigned gp0mode;
int enable_dynarec;

/*Branch compiling stuffi ... to clean up*/
uint32 halt_address;

/*Texture caching*/
uint32 	_texx,_texy,_tx_pal;

/*Sound stuff*/
int disable_sound;
uint16 *spuptr;

void redrawframe();
void ciao(char *ph);

/*Some Alpha timing stuff, delete after use*/
long gloubi;
uint32 ctstart,ctstop;