#include "sope.h"

/*Miscellaneous debugging functions*/
void dump_memory(uint32 addr) {
	FILE *g;
	char c[25];
	sprintf(c,"../dump-%8.8x",addr);
	g=fopen(c,"w");
	fwrite(ctx.gpr,4,32,g);
	fwrite(ctx.cp0,4,32,g);
	fwrite(RAOM,1,0x200000,g);
	fclose(g);
}

void print_regs() {
	int i,j;
	for (i=0;i<8;i++) {
		printf("%2u ",i);
		for (j=0;j<4;j++) printf("%8.8x - ",ctx.gpr[8*j+i]);
		printf("\n");
	}
	printf("LO:%8.8x HI:%8.8x\n",ctx.LO,ctx.HI);
}

void checkstop(uint32 addr,uint32 addr2) {
	if (addr==addr2) {
		printf("# Sope # Stopping at 0x%8.8x\n",addr2);
		dump_memory(addr2);
		print_regs();
		printf("nstp: %u\n",ctx.nstp);
		ciao("");
	}
}
